//
// Copyright (C) 2008-2011 Realmac Software Ltd
//
// These coded instructions, statements, and computer programs contain
// unpublished proprietary information of Realmac Software Ltd
// and are protected by copyright law. They may not be disclosed
// to third parties or copied or duplicated in any form, in whole or
// in part, without the prior written consent of Realmac Software Ltd.
//  Created by Alan Rogers on 7/03/11.
//

#import <AppKit/AppKit.h>

@interface EMBExternalEditorsHelper : NSObject

extern const NSInteger EMBExternalEditorsHelperOtherApplicationMenuItemTag;

- (NSMenu *)sourceEditorsMenu;
- (NSMenu *)imageEditorsMenu;

- (void)buildSourceEditorsMenuInPopupButton:(NSPopUpButton *)popupButton;
- (void)buildImageEditorsMenuInPopupButton:(NSPopUpButton *)popupButton;

- (void)refreshPopupButton:(NSPopUpButton *)popupButton;

/*!
	\brief
	Localised name of the default web browser, or nil if it cannot be determined.
 */
+ (NSString *)localisedDefaultBrowserName:(NSError **)errorRef;


/*!
	\brief
	Localised string for 'open in default browser'.
	e.g. "Open in Safari" or "Open in Default Browser" if the default browser 
	cannot be determined.
 */
+ (NSString *)localisedOpenInDefaultBrowserString;

@end
