//
// Copyright (C) 2010-2011 Realmac Software Ltd
//
// These coded instructions, statements, and computer programs contain
// unpublished proprietary information of Realmac Software Ltd
// and are protected by copyright law. They may not be disclosed
// to third parties or copied or duplicated in any form, in whole or
// in part, without the prior written consent of Realmac Software Ltd.
//

#import <Cocoa/Cocoa.h>

#import "RMSnapKit/RMSnapKit.h"
#import "EMBEmberKit/EMBEmberLibraryPresenter.h"

@class EMBEmberLibrary;

@interface EMBSnappingController : NSObject <EMBEmberLibraryPresenter>

@property (readonly, strong, nonatomic) NSOperationQueue *snappingOperationQueue;

/*
	Screen snapping
 */
- (void)screenSnapOfType:(RMScreenSnapType)type;

- (IBAction)snapDesktop:(id)sender;
- (IBAction)snapTimedDesktop:(id)sender;
- (IBAction)snapArea:(id)sender;
- (IBAction)snapWindow:(id)sender;
- (IBAction)recordArea:(id)sender;

- (void)setCurrentApplicationWindowsToHide:(NSArray *)windows;

/*
	Web snapping
 */
- (void)webSnapWithPageURL:(NSURL *)pageURL bookmarkOnly:(BOOL)bookmarkOnly pageWidth:(CGFloat)pageWidth pageCookies:(NSString *)pageCookies snapMetadata:(NSDictionary *)snapMetadata displayConfirmationUI:(BOOL)displayConfirmationUI;
- (void)webSnapWithImage:(RMWebSnapImage *)image bookmarkOnly:(BOOL)bookmarkOnly snapMetadata:(NSDictionary *)snapMetadata presentationWindow:(NSWindow *)presentationWindow completionHandler:(void (^)(NSManagedObjectID *snapObjectID, NSError *error))completionHandler;

@end
