//
//  EMBDownloadOperation.h
//  EmberTouch
//
//  Created by Damien DeVille on 02/12/2011.
//  Copyright (c) 2011 Realmac Software. All rights reserved.
//

#import <Foundation/Foundation.h>

#import "EMBEmberCoreConcurrency/EMBProgressOperation.h"

@protocol EMBDownloadOperationDelegate;

@interface EMBDownloadOperation : NSOperation <EMBProgressOperation>

- (id)initWithURLRequest:(NSURLRequest *)URLRequest saveToLocalURL:(NSURL *)localURL;

@property (readonly, copy, nonatomic) NSURLRequest *originalRequest;
@property (readonly, copy, nonatomic) NSURLRequest *currentRequest;

@property (weak, nonatomic) id <EMBDownloadOperationDelegate> delegate;

@property (readonly, copy, atomic) NSURL * (^completionProvider)(NSURLResponse **responseRef, NSError **errorRef);

@end

@protocol EMBDownloadOperationDelegate <NSObject>

 @optional
- (void)downloadOperation:(EMBDownloadOperation *)downloadOperation didReceiveResponse:(NSURLResponse *)response;

@end
