//
//  EMBProgressOperation.h
//  EmberCommon
//
//  Created by Damien DeVille on 01/10/2012.
//  Copyright (c) 2012 Realmac Software. All rights reserved.
//

#import <Foundation/Foundation.h>

@protocol EMBProgressOperation <NSObject>

 @required

extern NSString * const EMBProgressOperationProgressKey;
/*!
	\brief
	Normalized progress between 0.0 and 1.0.
 */
@property (readonly, atomic) double progress;

extern NSString * const EMBProgressOperationIndeterminateKey;
/*!
	\brief
	Whether the operation shows an indeterminate progress.
 */
@property (readonly, getter = isIndeterminate, atomic) BOOL indeterminate;

extern NSString * const EMBProgressOperationLocalisedTitleKey;
/*!
	\brief
	The operation progress title, localized.
 */
@property (readonly, copy, atomic) NSString *localisedTitle;

 @optional

extern NSString * const EMBProgressOperationDisableCancellationControlKey;
/*!
	\brief
	Whether the cancellation control should be disabled or hidden.
 */
@property (readonly, assign, atomic) BOOL disableCancellationControl;

@end
