//
//  EMBMigrationAttempt.h
//  EmberCommon
//
//  Created by Damien DeVille on 07/10/2012.
//  Copyright (c) 2012 Realmac Software. All rights reserved.
//

#import <Foundation/Foundation.h>

#import <CoreData/CoreData.h>

extern NSString * const EMBMigrationAttemptEntityName;

@interface EMBMigrationAttempt : NSManagedObject

+ (EMBMigrationAttempt *)createMigrationAttemptWithOriginLocation:(NSURL *)originLocation destinationLocation:(NSURL *)destinationLocation ubiquitous:(BOOL)ubiquitous managedObjectContext:(NSManagedObjectContext *)managedObjectContext persistentStore:(NSPersistentStore *)persistentStore;

extern NSString * const EMBMigrationAttemptSnapURIRepresentationKey;
@property (copy, nonatomic) NSString *snapURIRepresentation;

extern NSString * const EMBMigrationAttemptOriginLocationKey;
@property (copy, nonatomic) NSURL *originLocation;

extern NSString * const EMBMigrationAttemptOriginLocationStringKey;
@property (copy, nonatomic) NSString *originLocationString;

extern NSString * const EMBMigrationAttemptDestinationLocationKey;
@property (copy, nonatomic) NSURL *destinationLocation;

extern NSString * const EMBMigrationAttemptDestinationLocationStringKey;
@property (copy, nonatomic) NSString *destinationLocationString;

extern NSString * const EMBMigrationAttemptDateKey;
@property (strong, nonatomic) NSDate *date;

extern NSString * const EMBMigrationAttemptUbiquitousKey;
@property (getter = isUbiquitous, nonatomic) BOOL ubiquitous;

extern NSString * const EMBMigrationAttemptMigratingKey;
@property (getter = isMigrating, nonatomic) BOOL migrating;

@end
