//
//  EMBSharingUpload.h
//  EmberTouch
//
//  Created by Damien DeVille on 27/03/2012.
//  Copyright (c) 2012 Realmac Software. All rights reserved.
//

#import <CoreData/CoreData.h>

extern NSString * const EMBSharingUploadEntityName;

@class EMBSnap;

@interface EMBSharingUpload : NSManagedObject

+ (EMBSharingUpload *)createSharingUploadInManagedObjectContext:(NSManagedObjectContext *)managedObjectContext;

extern NSString * const EMBSharingUploadCreationDateKey;
@property (strong, nonatomic) NSDate *creationDate;

extern NSString * const EMBSharingUploadSnapURIRepresentationKey;
@property (strong, nonatomic) NSString *snapURIRepresentation;

extern NSString * const EMBSharingUploadPresetURIRepresentationKey;
@property (strong, nonatomic) NSString *presetURIRepresentation;

extern NSString * const EMBSharingUploadErrorKey;
@property (strong, nonatomic) id error;	// An NSCoding NSError

extern NSString * const EMBSharingUploadActiveKey;
@property (nonatomic, getter = isActive) BOOL active;

/*!
	\brief
	Generate an encodable version of the error.
 */
+ (id)encodableError:(id)error;

/*!
	\brief
	Return the snap matching the snapURI in the managed object context.
 */
- (EMBSnap *)snapInManagedObjectContext:(NSManagedObjectContext *)managedObjectContext error:(NSError **)errorRef;

/*!
	\return
	Return YES is both the preset and the snap still exist in the context.
	NO otherwise.
 */
- (BOOL)isValid;

#if TARGET_OS_IPHONE
+ (NSFetchedResultsController *)fetchedResultsControllerInManagedObjectContext:(NSManagedObjectContext *)managedObjectContext;
#endif /* TARGET_OS_IPHONE */

@end
