//
// Copyright (C) 2008-2012 Realmac Software Ltd
//
// These coded instructions, statements, and computer programs contain
// unpublished proprietary information of Realmac Software Ltd
// and are protected by copyright law. They may not be disclosed
// to third parties or copied or duplicated in any form, in whole or
// in part, without the prior written consent of Realmac Software Ltd.
//

#import "EMBSidebarItem.h"

extern NSString * const EMBSidebarFolderEntityName;

@interface EMBSidebarFolder : EMBSidebarItem

+ (EMBSidebarFolder *)createFolderInManagedObjectContext:(NSManagedObjectContext *)managedObjectContext persistentStore:(NSPersistentStore *)persistentStore title:(NSString *)title;

extern NSString * const EMBSidebarFolderExpandedKey;
@property (assign, getter = isExpanded, nonatomic) BOOL expanded;

extern NSString * const EMBSidebarFolderChildrenKey;
@property (readonly, strong, nonatomic) NSSet *children;

extern NSString * const EMBSidebarFolderOrderedChildrenKey;
@property (readonly, strong, nonatomic) NSArray *orderedChildren;

extern NSString * const EMBSidebarFolderItemsKey;
@property (readonly, strong, nonatomic) NSSet *items;

- (void)synchroniseSidebarIndexesFromOrder:(NSArray *)newChildOrder;
- (BOOL)item:(EMBSidebarItem *)item isAncestorOf:(EMBSidebarItem *)targetAncestor;
- (BOOL)checkFamilyTreeForItemMove:(EMBSidebarItem *)item;
- (void)moveChild:(EMBSidebarItem *)child toIndex:(NSUInteger)idx;
- (void)deleteChild:(EMBSidebarItem *)child;
- (void)insertChild:(EMBSidebarItem *)newChild atIndex:(NSUInteger)idx;
- (void)addChild:(EMBSidebarItem *)child;

@end

@interface EMBSidebarFolder (CoreDataGeneratedAccessors)

- (void)addChildrenObject:(EMBSidebarItem *)value;
- (void)removeChildrenObject:(EMBSidebarItem *)value;
- (void)addChildren:(NSSet *)value;
- (void)removeChildren:(NSSet *)value;

@end
