//
//  EMBSnapDocument+Content.h
//  EmberCommon
//
//  Created by Damien DeVille on 8/29/13.
//  Copyright (c) 2013 Realmac Software. All rights reserved.
//

#import <Foundation/Foundation.h>

#import "EMBEmberAnnotations/EMBEmberAnnotations.h"

@protocol EMBSnapInfo <NSObject>

@property (readonly, strong, nonatomic) NSNumber *documentVersion;
@property (readonly, strong, nonatomic) NSNumber *emberBuildNumber;
@property (readonly, strong, nonatomic) NSNumber *systemVersion;
@property (readonly, copy, nonatomic) NSString *systemType;
@property (strong, nonatomic) NSDate *snapDate;

@end

@protocol EMBSnapMetadata <NSObject>

@property (copy, nonatomic) NSString *uuid;
@property (copy, nonatomic) NSString *title;
@property (strong, nonatomic) NSNumber *rating;
@property (strong, nonatomic) NSNumber *type;
@property (copy, nonatomic) NSString *comments;
@property (copy, nonatomic) NSDate *date;
@property (copy, nonatomic) NSURL *URL;
@property (strong, nonatomic) NSArray *tags;
@property (strong, nonatomic) NSArray *collections;
@property (assign, nonatomic) BOOL hasAnnotations;
@property (assign, nonatomic) BOOL hasWebArchive;
@property (assign, nonatomic) CGSize mediaDimensions;
@property (assign, nonatomic) BOOL colourAnalysed;
@property (assign, nonatomic) NSNumber *colourRedComponent;
@property (assign, nonatomic) NSNumber *colourGreenComponent;
@property (assign, nonatomic) NSNumber *colourBlueComponent;
@property (strong, nonatomic) NSNumber *sortColourValue;

@property (copy, nonatomic) NSString *mediaFileName;
@property (copy, nonatomic) NSString *compositedImageFileName;
@property (copy, nonatomic) NSString *webArchiveFileName;

@property (readonly, assign, getter = isLayered, nonatomic) BOOL layered;

@end

@class EMBAnnotation;

@protocol EMBSnapAnnotations <NSObject>

@property (assign, nonatomic) EMBEmberAnnotationOrientation orientation;
@property (assign, nonatomic) CGRect cropFrame;

@property (readonly, strong, nonatomic) NSArray *annotations;
@property (readonly, strong, nonatomic) NSArray *userCreatedAnnotations;

@property (readonly, copy, nonatomic) NSString *dockPosition;
@property (readonly, copy, nonatomic) NSString *dockPinning;

@end

@protocol EMBSnapDocumentLittleSnapperSupport <NSObject>

- (id)initWithLittleSnapperBundleAtURL:(NSURL *)bundleURL forSavingToURL:(NSURL *)savingURL error:(NSError **)errorRef;

@end
