//
//  Ember-Constants.h
//  Ember
//
//  Created by Damien DeVille on 05/05/2012.
//  Copyright (c) 2012 Realmac Software. All rights reserved.
//

#import <TargetConditionals.h>
#import <Foundation/Foundation.h>

#if TARGET_OS_IPHONE
#import <CoreGraphics/CoreGraphics.h>
#endif /* TARGET_OS_IPHONE */

// Bundle identifiers
extern NSString * const EMBEmberBundleIdentifier;
extern NSString * const EMBEmberTouchBundleIdentifier;
extern NSString * const EMBEmberStatusItemBundleIdentifier;
extern NSString * const EMBEmberLibraryMediatorBundleIdentifier;

// Product names
extern NSString * const EMBEmberStatusItemProductName;
extern NSString * const EMBEmberLibraryMediatorProductName;

// Errors
extern NSString * const EMBEmberErrorDomain;

typedef NS_ENUM(NSInteger, EMBEmberErrorCode) {
	EMBEmberErrorCodeUnknown = 0,
	
	EMBEmberFileImportError = -100,
	
	EMBEmberFileExportError = -200,
	
	EMBEmberSavingError = -300,
};


// Little Snapper Snap bundle type
extern NSString * const EMBSnapBundleUTType;

// Ember Snap document type
extern NSString * const EMBSnapDocumentUTType;

// Snap Object URI pasteboard type
extern NSString * const EMBSnapObjectURIUTType;

// Subscription item Object URI pasteboard type
extern NSString * const EMBSubscriptionItemObjectURIUTType;

// Tag Object URI pasteboard type
extern NSString * const EMBTagObjectURIUTType;

// LittleSnapper library type
extern NSString * const EMBLittleSnapperLibraryUTType;

// Thumbnails
extern CGSize const EMBEmberSnapThumbnailSize;
extern CGSize const EMBEmberSubscriptionThumbnailSize;
extern CGSize const EMBEmberSubscriptionScrobblerSize;
