//
//  EMBSnapCompositedImageRefreshOperation.h
//  EmberCommon
//
//  Created by Damien DeVille on 30/04/2013.
//  Copyright (c) 2013 Realmac Software. All rights reserved.
//

#import <Foundation/Foundation.h>

#import "EMBEmberCoreConcurrency/EMBEmberCoreConcurrency.h"

@class NSManagedObjectID, NSManagedObjectContext;
@class EMBEmberLibrary;

@protocol EMBSnapCompositedImageRefreshOperationSnapDocumentLocationProvider <NSObject>

@property (readonly, copy, atomic) NSURL * (^completionProvider)(NSError **errorRef);

@end

@interface EMBSnapCompositedImageRefreshOperation : EMBConcurrentOperation <EMBProgressOperation>

- (id)initWithSnapObjectID:(NSManagedObjectID *)snapObjectID managedObjectContext:(NSManagedObjectContext *)managedObjectContext emberLibrary:(EMBEmberLibrary *)emberLibrary;
- (id)initWithSnapObjectID:(NSManagedObjectID *)snapObjectID snapDocumentLocationProvider:(NSOperation <EMBSnapCompositedImageRefreshOperationSnapDocumentLocationProvider> *)snapDocumentLocationProvider managedObjectContext:(NSManagedObjectContext *)managedObjectContext emberLibrary:(EMBEmberLibrary *)emberLibrary;

@property (readonly, copy, atomic) NSManagedObjectID * (^completionProvider)(NSError **errorRef);

@end
