//
//  EMBSnapDocumentCreationOperation.h
//  EmberCommon
//
//  Created by Damien DeVille on 24/10/2012.
//  Copyright (c) 2012 Realmac Software. All rights reserved.
//

#import <TargetConditionals.h>

#import "EMBEmberCoreConcurrency/EMBEmberCoreConcurrency.h"
#import "EMBEmberData/EMBEmberData.h"

@class NSManagedObjectID;

@protocol EMBSnapDocumentCreationOperationImageURLCompletionProvider <NSObject>

@property (readonly, atomic) NSURL * (^completionProvider)(NSError **);

@end

@protocol EMBSnapDocumentCreationOperationSnapObjectIDCompletionProvider <NSObject>

@property (readonly, atomic) NSManagedObjectID * (^completionProvider)(NSError **);

@end

@protocol EMBSnapDocumentCreationOperationLittleSnapperBundleURLCompletionProvider <NSObject>

@property (readonly, atomic) NSURL * (^completionProvider)(NSError **);

@end

@interface EMBSnapDocumentCreationOperation : EMBConcurrentOperation

- (id)initWithSnapDocumentLocation:(NSURL *)snapDocumentLocation managedObjectContext:(NSManagedObjectContext *)managedObjectContext imageURLProvider:(NSOperation <EMBSnapDocumentCreationOperationImageURLCompletionProvider> *)imageURLProvider snapObjectIDProvider:(NSOperation <EMBSnapDocumentCreationOperationSnapObjectIDCompletionProvider> *)snapObjectIDProvider;

#if !TARGET_OS_IPHONE
- (id)initWithSnapDocumentLocation:(NSURL *)snapDocumentLocation littleSnapperBundleURLProvider:(NSOperation <EMBSnapDocumentCreationOperationLittleSnapperBundleURLCompletionProvider> *)littleSnapperBundleURLProvider;
#endif /* !TARGET_OS_IPHONE */

@property (readonly, copy, atomic) EMBSnapDocument * (^completionProvider)(NSError **errorRef);

@end
