//
//  EMBSnapDocumentUpdateOperation.h
//  EmberCommon
//
//  Created by Damien DeVille on 12/3/13.
//  Copyright (c) 2013 Realmac Software. All rights reserved.
//

#import "EMBEmberCoreConcurrency/EMBEmberCoreConcurrency.h"

@class NSManagedObjectID, NSManagedObjectContext;
@class EMBEmberLibrary, EMBSnapDocument;

@protocol EMBSnapDocumentUpdateOperationSnapDocumentLocationProvider <NSObject>
@property (readonly, copy, atomic) NSURL * (^completionProvider)(NSError **);
@end

@interface EMBSnapDocumentUpdateOperation : EMBConcurrentOperation

/*!
	\brief
	
	\param (required) snapObjectID: the managed object ID of the snap.
	\param (optional) snapDocumentLocationProvider: a provider for the snap document location. If not specified, the location recorded in the snap object will be used.
	\param (required) managedObjectContext: the managed object context to retrieve the snap.
	\param (required) emberLibrary: the Ember library the snap lives in.
 */
- (id)initWithSnapObjectID:(NSManagedObjectID *)snapObjectID snapDocumentLocationProvider:(NSOperation <EMBSnapDocumentUpdateOperationSnapDocumentLocationProvider> *)snapDocumentLocationProvider managedObjectContext:(NSManagedObjectContext *)managedObjectContext emberLibrary:(EMBEmberLibrary *)emberLibrary;

@property (readonly, copy, atomic) EMBSnapDocument * (^completionProvider)(NSError **errorRef);

@end
