//
//  EMBWebArchiveSnapOperation.h
//  EmberCommon
//
//  Created by Damien DeVille on 31/07/2013.
//  Copyright (c) 2013 Realmac Software. All rights reserved.
//

#import <TargetConditionals.h>

#if !TARGET_OS_IPHONE

#import <Cocoa/Cocoa.h>

#import "EMBEmberCoreConcurrency/EMBEmberCoreConcurrency.h"

@class EMBEmberLibrary;

@interface EMBWebArchiveSnapOperation : EMBConcurrentOperation <EMBProgressOperation>

- (id)initWithWebArchiveData:(NSData *)webArchiveData pageSize:(CGSize)pageSize cropRect:(CGRect)cropRect managedObjectContext:(NSManagedObjectContext *)managedObjectContext emberLibrary:(EMBEmberLibrary *)emberLibrary;

@property (readonly, copy, atomic) NSManagedObjectID * (^completionProvider)(NSError **errorRef);

@end

@interface EMBWebArchiveSnapOperation (/* Import customization */)

@property (strong, nonatomic) NSDictionary *snapMetadata;

@end

#endif /* !TARGET_OS_IPHONE */
