//
//  EMBWebSnapImportOperation.h
//  EmberCommon
//
//  Created by Damien DeVille on 06/10/2012.
//  Copyright (c) 2012 Realmac Software. All rights reserved.
//

#import <TargetConditionals.h>

#if !TARGET_OS_IPHONE

#import <AppKit/AppKit.h>

#import "EMBEmberOperations/EMBImportOperation.h"

@class RMWebSnapImage;
@class NSManagedObjectContext;
@class EMBEmberLibrary;

@protocol EMBWebSnapImportOperationImageProvider <NSObject>

@property (readonly, copy, atomic) RMWebSnapImage * (^completionProvider)(NSError **);

@end

@interface EMBWebSnapImportOperation : EMBImportOperation

- (id)initWithImageProvider:(NSOperation <EMBWebSnapImportOperationImageProvider> *)imageProvider bookmarkOnly:(BOOL)bookmarkOnly managedObjectContext:(NSManagedObjectContext *)managedObjectContext emberLibrary:(EMBEmberLibrary *)emberLibrary;

@property (readonly, copy, atomic) NSManagedObjectID * (^completionProvider)(NSError **errorRef);

@end

#endif /* !TARGET_OS_IPHONE */
