//
//  EMBUploadOperation.h
//  EmberTouch
//
//  Created by Damien DeVille on 23/01/2012.
//  Copyright (c) 2012 Realmac Software. All rights reserved.
//

#import <Foundation/Foundation.h>

#import "EMBEmberCoreConcurrency/EMBEmberCoreConcurrency.h"

@class NSManagedObjectID, NSManagedObjectContext;
@class RMUploadConfinementPlugin;
@class EMBEmberLibrary;

extern NSString * const EMBSharingUploadOperationExportTitleOptionKey;

@interface EMBSharingUploadOperation : EMBConcurrentOperation <EMBProgressOperation>

/*!
	\brief
	Initialised with a sharing upload, uploads and if it succeeds, creates an EMBSharingDestination with the result
 */
- (id)initWithSharingUploadObjectID:(NSManagedObjectID *)sharingUploadObjectID managedObjectContext:(NSManagedObjectContext *)managedObjectContext emberLibrary:(EMBEmberLibrary *)emberLibrary exportOptions:(NSDictionary *)exportOptions;

typedef NSManagedObjectID * (^EMBUploadOperationCompletionProvider)(NSError **);
/*!
	\brief
	An array of EMBSharingDestination objectIDs or an error.
 */
@property (readonly, copy, atomic) EMBUploadOperationCompletionProvider completionProvider;

@end
