//
//  RMLiveViewPopover.h
//  Analog
//
//  Created by Keith Duncan on 08/03/2011.
//  Copyright 2011 Realmac Software. All rights reserved.
//

#import <Cocoa/Cocoa.h>

@class RMPopoverBackgroundView;

extern NSString *const RMPopoverViewControllerCloseNotificationReasonKey;
	extern NSString *const RMPopoverViewControllerCloseNotificationReasonBehaviour;

extern NSString *const RMPopoverViewControllerWillShowNotificationName;
extern NSString *const RMPopoverViewControllerDidShowNotificationName;

extern NSString *const RMPopoverViewControllerWillCloseNotificationName;
extern NSString *const RMPopoverViewControllerDidCloseNotificationName;

/*!
	\brief
	
 */
@interface RMPopoverViewController : NSViewController

/*!
	\brief
	MUST be set before showing.
 */
@property (retain, nonatomic) RMPopoverBackgroundView *backgroundView;

enum {
	RMPopoverViewControllerBehaviourApplicationDefined = 0,
	RMPopoverViewControllerBehaviourSemitransient = 1,
};
typedef NSInteger RMPopoverViewControllerBehaviour;
@property (assign, nonatomic) RMPopoverViewControllerBehaviour behaviour;

extern NSString *const RMPopoverViewControllerContentViewControllerKey;
/*!
	\brief
	Observed and will update the receiver's content view.
 */
@property (retain, nonatomic) IBOutlet NSViewController *contentViewController;

/*!
	\brief
	
 */
- (void)showRelativeToRect:(CGRect)positioningRect ofView:(NSView *)positioningView preferredEdge:(CGRectEdge)preferredEdge;

/*!
	\brief
	YES on return from `showRelativeToRect:ofView:preferredEdge:`, NO on return from `-performClose:`
 */
@property (readonly, getter=isVisible, nonatomic) BOOL visible;

/*!
	\brief
	Close the containing window.
 */
- (IBAction)performClose:(id)sender;

/*!
	\brief
	Extra-popover events schedule the popover to be closed at the end of the current run loop iteration, to prevent this, call this method.
 */
- (void)suppressClose;

@end

/*!
	\brief
	
 */
@interface NSViewController (RMPopoverAdditions)

@property (readonly, assign, nonatomic) RMPopoverViewController *parentPopover;

@end
