//
//  RMRegistrationKit-Macros.h
//  RMRegistrationKit
//
//  Created by Damien DeVille on 2/12/14.
//  Copyright (c) 2014 Realmac Software. All rights reserved.
//

#import <Foundation/Foundation.h>

#define RM_REG_SCOPE_EXIT(function) __attribute__((cleanup(function)))

static inline void RMRegCallScopedBlock(dispatch_block_t const *blockRef) {
	if (*blockRef != NULL) (*blockRef)();
}

#define rm_reg_scoped_block_t dispatch_block_t __attribute__((unused)) RM_REG_SCOPE_EXIT(RMRegCallScopedBlock)
