//
//  SRValidator.h
//  ShortcutRecorder
//
//  Copyright 2006-2007 Contributors. All rights reserved.
//
//  License: BSD
//
//  Contributors:
//      David Dauer
//      Jesper
//      Jamie Kirkpatrick

#import <Cocoa/Cocoa.h>

@class SRValidator;

@protocol SRValidatorDelegate <NSObject>

- (BOOL)shortcutValidator:(SRValidator *)validator canUseKeyCode:(NSInteger)keyCode withCocoaFlags:(NSUInteger)cocoaFlags reason:(NSString **)reasonRef;

@end

@interface SRValidator : NSObject

- (id)initWithDelegate:(id <SRValidatorDelegate>)delegate;

@property (assign, nonatomic) id <SRValidatorDelegate> delegate;

- (BOOL)canUseKeyEquivalentFromEvent:(NSEvent *)event menu:(NSMenu *)menu error:(NSError **)errorRef;

@end
